# This file was created automatically by SWIG.
import activeareac
from oof2.SWIG.common.cpixelselection import CPixelSelectionPtr
from oof2.SWIG.common.pixelattribute import PxlAttributeRegistrationPtr
class ActiveAreaPtr(CPixelSelectionPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def __del__(self,activeareac=activeareac):
        if self.thisown == 1 :
            activeareac.delete_ActiveArea(self)
    def clone(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveArea_clone,(self,) + _args, _kwargs)
        if val: val = ActiveAreaPtr(val) ; val.thisown = 1
        return val
    def isActive(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveArea_isActive,(self,) + _args, _kwargs)
        return val
    def override(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveArea_override,(self,) + _args, _kwargs)
        return val
    def getOverride(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveArea_getOverride,(self,) + _args, _kwargs)
        return val
    def add_pixels(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveArea_add_pixels,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C ActiveArea instance at %s>" % (self.this,)
class ActiveArea(ActiveAreaPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(activeareac.new_ActiveArea,_args,_kwargs)
        self.thisown = 1




class ActiveAreasAttributeRegistrationPtr(PxlAttributeRegistrationPtr):
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def createAttribute(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveAreasAttributeRegistration_createAttribute,(self,) + _args, _kwargs)
        return val
    def set_comparable(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveAreasAttributeRegistration_set_comparable,(self,) + _args, _kwargs)
        return val
    def get_comparable(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveAreasAttributeRegistration_get_comparable,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C ActiveAreasAttributeRegistration instance at %s>" % (self.this,)
class ActiveAreasAttributeRegistration(ActiveAreasAttributeRegistrationPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(activeareac.new_ActiveAreasAttributeRegistration,_args,_kwargs)
        self.thisown = 1




class ActiveAreaListPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def add(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveAreaList_add,(self,) + _args, _kwargs)
        return val
    def remove(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveAreaList_remove,(self,) + _args, _kwargs)
        return val
    def getNames(self, *_args, **_kwargs):
        val = apply(activeareac.ActiveAreaList_getNames,(self,) + _args, _kwargs)
        return val
    def __repr__(self):
        return "<C ActiveAreaList instance at %s>" % (self.this,)
class ActiveAreaList(ActiveAreaListPtr):
    def __init__(self,this):
        self.this = this






#-------------- FUNCTION WRAPPERS ------------------

def areaListFromPixel(*_args, **_kwargs):
    val = apply(activeareac.areaListFromPixel,_args,_kwargs)
    if val: val = ActiveAreaListPtr(val)
    return val



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: activearea.spy,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2005/10/18 17:31:08 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov.

## The active regions of a Microstructure are stored in an ActiveArea
## object, which is basically the same as a PixelSelection.
## ActiveAreas and PixelSelections share a C++ base class,
## CPixelSelection.  Each Python Microstructure holds a Python
## ActiveAreaContext, which is the WhoDoUndoClass for ActiveAreas.
## The CMicrostructures contain a pointer to the current ActiveArea in
## the ActiveAreaContext.

## In the CPixelSelection object, it's the INactive pixels that are
## explicitly stored, so that clearing the ActiveArea is the same as
## making all pixels active.

from oof2.SWIG.common import switchboard
from oof2.common import color
from oof2.common import debug
from oof2.common.IO import whoville
from oof2.common.IO import display
from oof2.common.IO import bitoverlaydisplay
from oof2.common.IO import topwho            # defines <top activearea>

class NamedActiveArea:
    def __init__(self, name, activearea):
        self.name = name
        self.activearea = activearea

#####################################

class ActiveAreaContext(whoville.WhoDoUndo):
    def __init__(self, path, classname, obj):
        # override==1 means that all pixels are active, despite what's
        # stored in the pixel selection.
        self._override = 0
        whoville.WhoDoUndo.__init__(self, path, classname, obj)
    def start(self):
        newselection = self.getObject().clone()
        self.pushModification(newselection)
    def selectWithoutCheck(self, selectioncourier):
        self.getObject().selectWithoutCheck(selectioncourier)
        switchboard.notify('pixel selection changed')
    def unselectWithoutCheck(self, selectioncourier):
        self.getObject().unselectWithoutCheck(selectioncourier)
        switchboard.notify('pixel selection changed')
    def toggleWithoutCheck(self, selectioncourier):
        self.getObject().toggleWithoutCheck(selectioncourier)
        switchboard.notify('pixel selection changed')
    def clear(self):
        self.getObject().clearWithoutCheck()
    def invert(self):
        self.getObject().invertWithoutCheck()
    def undo(self):
        self.undoModification()
    def redo(self):
        self.redoModification()
    def clearable(self):
        return self.size() != 0
    def size(self):
        return len(self.getObject())
    def override(self, flag):
        # Keep the C++ flags in the ActiveAreas synchronized
        # with the Python flag in the ActiveAreaContext.
        for aa in self.undobuffer:
            aa.override(flag)
        self.getTimeStamp(None).increment()
        self._override = flag
    def getOverride(self):
        return self._override
    def isActive(self, pixel):
        return self.getObject().isActive(pixel)
    def getBitmap(self):
        if not self._override:
            return self.getObject().getBitmap()
    # This doesn't do what you think.  Active areas store lists of
    # *inactive* pixels, and this returns the list of selected pixels,
    # which are *inactive*.  Did I mention *inactive*?
    def getSelection(self):
        return self.getObject().members()
    def getSelectionAsGroup(self):
        return self.getObject().getPixelGroup()

activeareaWhoClass = whoville.WhoDoUndoClass(
    'Active Area',
    instanceClass=ActiveAreaContext,
    ordering=998,
    secret=0,
    proxyClasses=['<top activearea>'])

display.predefineLayer(
    'Active Area',
    '<top activearea>',
    bitoverlaydisplay.bitmapOverlay(color=color.white, opacity=0.8))

#####

aa_attr_reg = ActiveAreasAttributeRegistration()

# writeData command, called from microstructureIO.py in the definition
# of pixel categories.  Writes out the active areas to which the
# representative pixel belongs, or False if there are none.
def _AAReg_writeData(self, datafile, ms, reppxl):
    if reppxl is None:
        return False
    alist = areaListFromPixel(ms, reppxl);
    namelist = alist.getNames()
    if len(namelist)==0:
        return False
    datafile.argument('active_areas', namelist)
    return True

ActiveAreasAttributeRegistrationPtr.writeData = _AAReg_writeData
