# This file was created automatically by SWIG.
import subproblemc
from oof2.SWIG.engine.femesh import FEMeshPtr
class SubProblemPtr :
    def __init__(self,this):
        self.this = this
        self.thisown = 0
    def set_freedofmap(self, *_args, **_kwargs):
        val = apply(subproblemc.SubProblem_set_freedofmap,(self,) + _args, _kwargs)
        return val
    def __del__(self,subproblemc=subproblemc):
        if self.thisown == 1 :
            subproblemc.delete_SubProblem(self)
    def __repr__(self):
        return "<C SubProblem instance at %s>" % (self.this,)
class SubProblem(SubProblemPtr):
    def __init__(self,*_args,**_kwargs):
        self.this = apply(subproblemc.new_SubProblem,_args,_kwargs)
        self.thisown = 1






#-------------- FUNCTION WRAPPERS ------------------



#-------------- VARIABLE WRAPPERS ------------------



#-------------- USER INCLUDE -----------------------

# -*- python -*-
# $RCSfile: subproblem.spy,v $
# $Revision: 1.1 $
# $Author: langer $
# $Date: 2005/10/18 17:31:27 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

import oof2.engine.mesh
from oof2.common import debug
from oof2.common.IO import whoville
from oof2.SWIG.engine import equation
from oof2.SWIG.engine import field
__subp_old_init = SubProblem.__init__
def __init(self, name, all = None):
    self.name = name
    self.active_fields = {}
    self.in_plane_fields = {}
    self.active_equations = {}
    self.active_kinetics = {}
    self.active_dynamics = {}
    self.matrixdriver = None
    self.timedriver = None
    self.active_region = None
    __subp_old_init(self)
SubProblem.__init__ = __init

## Equations
def __activateEquation(self, equation):
    self.active_equations[equation.name()] = equation
SubProblemPtr.activateEquation = __activateEquation

def __deactivateEquation(self, equation):
    try:
        del self.active_equations[equation.name()]
    except KeyError:
        pass
SubProblemPtr.deactivateEquation = __deactivateEquation

def __is_active_equation(self, equation):
    return equation.name() in self.active_equations
SubProblemPtr.is_active_equation = __is_active_equation

# Returns all the equations which are active in this subproblem.
def _allEquations(self):
    return self.active_equations.values()

SubProblemPtr.allEquations = _allEquations

def __is_kinetically_active(self, equation):
    return equation.name() in self.active_kinetics
SubProblemPtr.is_kinetically_active = __is_kinetically_active

def __is_dinamically_active(self, equation):
    return equation.name() in self.active_dynamics
SubProblemPtr.is_dynamically_active = __is_dinamically_active

## Fields
def __activateField(self, field):
    self.active_fields[field.name()] = field
SubProblemPtr.activateField = __activateField

def __is_active_field(self, field):
    return field.name() in self.active_fields
SubProblemPtr.is_active_field = __is_active_field

def __deactivateField(self, field):
    try:
        del self.active_fields[field.name()]
    except KeyError:
        pass
SubProblemPtr.deactivateField = __deactivateField

def __inPlaneField(self, field):
    self.in_plane_fields[field.name()] = field
SubProblemPtr.inPlaneField = __inPlaneField

def __outOfPlaneField(self, field):
    try:
        del self.in_plane_fields[field.name()]
    except KeyError:
        pass
SubProblemPtr.outOfPlaneField = __outOfPlaneField

def __is_in_plane(self, field):
    return field.name() in self.in_plane_fields
SubProblemPtr.is_in_plane = __is_in_plane

## Active region name
def __setActiveRegion(self, skeleton, group):
    self.active_region = (skeleton, group)
SubProblemPtr.setActiveRegion = __setActiveRegion

def __getActiveRegion(self):
    return self.active_region
SubProblemPtr.getActiveRegion = __getActiveRegion
## Activate kinetics
def __activateKinetics(self, equation):
    self.active_kinetics[equation.name()] = equation
SubProblemPtr.activateKinetics = __activateKinetics
def __deactivateKinetics(self, equation):
    del self.active_kinetics[equation.name()]
SubProblemPtr.deactivateKinetics = __deactivateKinetics
## Activate dynamics
def __activateDynamics(self, equation):
    self.active_dynamics[equation.name] = equation
SubProblemPtr.activateDynamics = __activateDynamics
def __deactivateDynamics(self, equation):
    del self.active_dynamics[equation.name()]
SubProblemPtr.deactivateDynamics = __deactivateDynamics
def __setMatrixDriver(self, matrixdriver):
    self.matrixdriver = matrixdriver
SubProblemPtr.setMatrixDriver = __setMatrixDriver
def __setTimeDriver(self, timedriver):
    self.timedriver = timedriver
SubProblemPtr.setTimeDriver = __setTimeDriver


##
##
## METHODS FOR SOLVING SUBMESHES START HERE
##
##
##
def __activateEquations(self, meshcontext):
    femesh =  meshcontext.femesh()
    ## activate equations the *official* way.
    for eqn in equation.allEquations:
        if eqn.name() in self.active_equations:
            femesh.activate_equation(eqn)
            if eqn.name() in self.active_kinetics:
                femesh.kinetic_activate_equation(eqn)
            if eqn.name() in self.active_dynamics:
                femesh.activate_dynamics(eqn)
    meshcontext.autoenableBCs()
SubProblemPtr.activateEquations = __activateEquations

def __activateFields(self, meshcontext):
    femesh =  meshcontext.femesh()
    for fld in field.allFields:
        if fld.name() in self.active_fields:
            femesh.activate_field(fld)
            if fld.name() in self.in_plane_fields:
                fld.set_in_plane(femesh, 1)
    
    meshcontext.autoenableBCs()
SubProblemPtr.activateFields = __activateFields

def __selectElements(self, meshcontext):
    femesh =  meshcontext.femesh()
    ## elements and DOFs are set to be unsubmeshable
    skelname, group = meshcontext.getActiveRegion()
    skelc = whoville.getClass('Skeleton')[skelname]
    members = skelc.elementgroups.get_group(group)
    for skel_el in members:
        element = self.mesh.getElement(skel_el.meshindex)
        element.setsubmesh()
SubProblemPtr.selectElements = __selectElements

def __initializeMesh(self, meshcontext):
    femesh = meshcontext.mesh()
    femesh.do_not_solve_all()
    self.activateEquations(meshcontext)
    self.activateFields(meshcontext)
    self.selectElements(meshcontext)

            
    

def __precompute(self, meshcontext): ## mesh is the colon separated mesh name
    ## meshcontext = oof2.engine.mesh.meshes[mesh]
    femesh =  meshcontext.femesh()
    ## activate equations the *official* way.
    for eqn in femesh.all_equations():
        if eqn.name() in self.active_equations:
            femesh.activate_equation(equation)
            ## switchboard.notify('equation activated', mesh, eqn.name(), 1)
            if eqn.name() in self.active_kinetics:
                femesh.kinetic_activate_equation(equation)
                ##switchboard.notify('kinetics activated', mesh, eqn.name(), 1)
            if eqn.name() in self.active_dynamics:
                femesh.activate_dynamics(equation)
                ## switchboard.notify('dynamics activated', mesh, eqn.name(), 1)
            
    ## activate fields, also the *official* way.
    for fld in femesh.all_fields():
        if fld.name() in self.active_fields:
            femesh.deactivate_field(field)
            ## switchboard.notify("field activated", mesh, fld.name(), 1)
    ## select active region
    ## elements and DOFs are set to be unsubmeshable
    skelname, group = meshcontext.getActiveRegion()
    skelc = whoville.getClass('Skeleton')[skelname]
    members = skelc.elementgroups.get_group(group)
    for skel_el in members:
        element = self.mesh.getElement(skel_el.meshindex)
        element.setsubmesh()
SubProblemPtr.precompute = __precompute

def __apply(self, mesh): 
    meshcontext = oof2.engine.mesh.meshes[mesh]
    femesh =  meshcontext.femesh()
    self.timedriver.apply_one_step(self.matrixdriver, meshcontext) ## DOES NOT UPDATE TIME INDEX
SubProblemPtr.apply = __apply

def __deactivateEquations(self, meshcontext):
    femesh =  meshcontext.femesh()
    ## deactivate equations the *official* way.
    for eqn in equation.allEquations:
        if eqn.name() in self.active_equations:
            femesh.deactivate_equation(eqn)
            if eqn.name() in self.active_kinetics:
                femesh.kinetic_deactivate_equation(eqn)
            if eqn.name() in self.active_dynamics:
                femesh.deactivate_dynamics(eqn)
SubProblemPtr.deactivateEquations = __deactivateEquations

def __deactivateFields(self, meshcontext):
    femesh =  meshcontext.femesh()
    for fld in field.allFields:
        if fld.name() in self.active_fields:
            femesh.deactivate_field(fld)
            if fld.name() in self.in_plane_fields:
                fld.set_in_plane(femesh, 0)
SubProblemPtr.deactivateFields = __deactivateFields

def __unselectElements(self, meshcontext):
    ## unselect elements
    skelname, group = meshcontext.getActiveRegion()
    skelc = whoville.getClass('Skeleton')[skelname]
    members = skelc.elementgroups.get_group(group)
    for skel_el in members:
        element = self.mesh.getElement(skel_el.meshindex)
        element.unsetsubmesh()
SubProblemPtr.unselectElements = __unselectElements

def __restoreMesh(self, meshcontext):
    self.deactivateEquations(meshcontext)
    self.deactivateFields(meshcontext)
    self.unselectElements(meshcontext)
SubProblemPtr.restoreMesh = __restoreMesh
    
def __postcompute(self, mesh):
    meshcontext = oof2.engine.mesh.meshes[mesh]
    femesh =  meshcontext.femesh()
    self.set_freedofmap(femesh) ## will be used to accept/reject solution
SubProblemPtr.postcompute = __postcompute

##
##
## METHODS FOR SOLVING SUBMESHES END HERE
##
##
##


##
##
## THE ALL SUBPROBLEM
##
##

class SubProblemAll(SubProblem):
    def __init__(self, name):
        SubProblem.__init__(self, name)
    def initializeMesh(self, meshcontext):
        femesh = meshcontext.mesh()
        femesh.do_solve_all()
        self.activateEquations(meshcontext)
        self.activateFields(meshcontext)
    def restoreMesh(self, meshcontext):
        self.deactivateEquations(meshcontext)
        self.deactivateFields(meshcontext)


