# -*- python -*-
# $RCSfile: initialize.py,v $
# $Revision: 1.75 $
# $Author: reida $
# $Date: 2005/11/09 16:32:08 $

# This software was produced by NIST, an agency of the U.S. government,
# and by statute is not subject to copyright in the United States.
# Recipients of this software assume all responsibilities associated
# with its operation, modification and maintenance. However, to
# facilitate maintenance we ask that before distributing modified
# versions of this software, you first contact the authors at
# oof_manager@ctcms.nist.gov. 

from oof2.common import debug
from oof2.SWIG.common import devel
# engine specific GUI initialization code

import oof2.engine.initialize

# Import widgets before GUI page definitions.
import oof2.engine.IO.GUI.adaptivemeshrefineWidget
import oof2.engine.IO.GUI.bdymodparamwidget
import oof2.engine.IO.GUI.boundarybuilderGUI
import oof2.engine.IO.GUI.cijklparamwidgets
import oof2.engine.IO.GUI.invariantwidget
import oof2.engine.IO.GUI.materialwidget
import oof2.engine.IO.GUI.meshcswidget
import oof2.engine.IO.GUI.meshdataGUI
import oof2.engine.IO.GUI.meshparamwidgets
import oof2.engine.IO.GUI.newmeshWidget
import oof2.engine.IO.GUI.profilefunctionwidget
import oof2.engine.IO.GUI.rank3tensorwidgets
import oof2.engine.IO.GUI.skeletonbdyGUI
import oof2.engine.IO.GUI.skeletongroupwidgets
import oof2.engine.IO.GUI.strainwidget
import oof2.engine.IO.GUI.tensorwidgets

# Toolbox definitions
import oof2.engine.IO.GUI.meshcstoolboxGUI
import oof2.engine.IO.GUI.meshinfoGUI
import oof2.engine.IO.GUI.movenodeGUI
import oof2.engine.IO.GUI.pinnodesGUI
import oof2.engine.IO.GUI.pixelinfoGUI
import oof2.engine.IO.GUI.skeletoninfoGUI
import oof2.engine.IO.GUI.skeletonselectiontoolboxGUI

# GUI callback for profile-save menu item.
import oof2.engine.IO.GUI.profileGUI

# GUI page definitions.
import oof2.engine.IO.GUI.analyzePage
import oof2.engine.IO.GUI.boundaryAnalysisPage
import oof2.engine.IO.GUI.boundarycondPage
import oof2.engine.IO.GUI.equationPage
import oof2.engine.IO.GUI.fieldPage
import oof2.engine.IO.GUI.materialsPage
import oof2.engine.IO.GUI.meshPage
import oof2.engine.IO.GUI.pinnodesPage
import oof2.engine.IO.GUI.skeletonBoundaryPage
import oof2.engine.IO.GUI.skeletonPage
import oof2.engine.IO.GUI.skeletonSelectionPage
import oof2.engine.IO.GUI.solverPage


if devel.devel():
    import oof2.engine.IO.GUI.subproblemPage
