// -*- C++ -*-
// $RCSfile: heatcapacity.C,v $
// $Revision: 1.6 $
// $Author: langer $
// $Date: 2005/11/16 22:28:33 $

/* This software was produced by NIST, an agency of the U.S. government,
 * and by statute is not subject to copyright in the United States.
 * Recipients of this software assume all responsibilities associated
 * with its operation, modification and maintenance. However, to
 * facilitate maintenance we ask that before distributing modified
 * versions of this software, you first contact the authors at
 * oof_manager@ctcms.nist.gov. 
 */

#include <oofconfig.h>
#include "common/coord.h"
#include "heatcapacity.h"
#include "engine/element.h"
#include "engine/elementnodeiterator.h"
#include "engine/field.h"
#include "engine/flux.h"
#include "engine/indextypes.h"
#include "engine/material.h"
#include "engine/femesh.h"
#include "common/space.h"
#include "common/trace.h"
#include "common/ooferror.h"

HeatCapacity::HeatCapacity(PyObject *reg, const std::string &nm, double cp)
  : ScalarTimeDerivPrefactor(nm,reg, cp)
{
  temperature = dynamic_cast<ScalarField*>(Field::getField("Temperature"));
  heat_flux = dynamic_cast<VectorFlux*>(Flux::getFlux("Heat_Flux"));
}

int HeatCapacity::K_order(const FEMesh*, const Element*) const {
  return 0;
}

